attribute vec4 a_position;
attribute vec2 a_texcoord_0;
attribute vec2 a_texcoord_1;

varying vec4 v_uvs_light;  // (distorted x, distorted y, scrolled distorted x, lighting)

uniform mat4  u_mtx_modelviewproj;
uniform vec3 u_vec3_translation;  // RTT translation (camera offset, aspect ratio, unused)

void main()
{
	// Transform vertex position.
	gl_Position = u_mtx_modelviewproj * a_position;
	
	// Apply the texture coordinate offsets to the base texture coordinates.
	vec2 tc_0 = a_texcoord_0 * vec2(u_vec3_translation.y, 1.0) + vec2(u_vec3_translation.x, 0.0);
	v_uvs_light.xy = a_texcoord_1 * 0.2 + tc_0;
	
	// Light the vertex based on how distorted the coordinates are (which means a steeper angle of geometry).
	float intensity = -a_texcoord_1.x;
	v_uvs_light.w = pow(intensity * 3.0, 2.0) + (intensity * 3.5);
}
